SystemOrganization addCategory: #'Spec-Core'!

!SequenceableCollection methodsFor: '*Spec-Core' stamp: ''!
asValueHolder

	^ CollectionValueHolder contents: self! !

!Dictionary methodsFor: '*Spec-Core' stamp: ''!
asValueHolder

	^ DictionaryValueHolder contents: self! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
getIndexSelector: aSelector

	getIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
getSelectionListSelector: getListSel.

	getSelectionListSelector := getListSel! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
initialize

	super initialize.
	self initForKeystrokes.! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
setIndexSelector: aSelector

	setIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
setMultipleSelection: aBoolean

	multipleSelection := aBoolean! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
setSelectionListSelector: getListSel.

	setSelectionListSelector := getListSel! !

Announcement subclass: #ValueChanged
	instanceVariableNames: 'newContents oldContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!ValueChanged commentStamp: '<historical>' prior: 0!
A ValueChanged is an announcement raised when a value of a NewValueHolder is changed!

!ValueChanged class methodsFor: 'instance creation' stamp: ''!
newContents: newContents

	^ self new
		newContents: newContents;
		yourself! !

!ValueChanged class methodsFor: 'instance creation' stamp: ''!
oldContents: oldContent newContents: newContent

	^ self new
		newContents: newContent;
		oldContents: oldContent;
		yourself! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
newContents

	^ newContents! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
newContents: anObject
	
	newContents := anObject! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
oldContents

	^ oldContents! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
oldContents: anObject
	
	oldContents := anObject! !

!Morph methodsFor: '*Spec-Core' stamp: ''!
addMorphWrapper: aMorphWrapper
	
	
	aMorphWrapper addIn: self.! !

!LayoutFrame methodsFor: '*Spec-Core' stamp: ''!
fractions: fractionsOrNil offsets: offsetsOrNil

	| fractions offsets |

	fractions := fractionsOrNil ifNil: [0@0 extent: 0@0].
	offsets := offsetsOrNil ifNil: [0@0 extent: 0@0].
	
	^self
		topFraction: fractions top offset: offsets top;
		leftFraction: fractions left offset: offsets left;
		bottomFraction: fractions bottom offset: offsets bottom;
		rightFraction: fractions right offset: offsets right
! !

Object subclass: #ComposableModel
	instanceVariableNames: 'focusOrder morph owner bindings'
	classVariableNames: 'Bindings'
	poolDictionaries: ''
	category: 'Spec-Core'!

!ComposableModel commentStamp: '<historical>' prior: 0!
ComposableModel is an abstract which represent a applicative model made to be composed with other ComposableModel!

!ComposableModel class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/23/2012 16:49'!
bindings

	"^ Bindings ifNil: [ Bindings := self defaultBindings ]"
	^ self defaultBindings! !

!ComposableModel class methodsFor: 'initialize' stamp: ''!
defaultBindings

	^ MorphicBindings new! !

!ComposableModel class methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 3/22/2012 14:17'!
defaultClassesBinding

	^ IdentityDictionary new
		at: #List put: #PluggableListMorph;
		at: #IconList put: #PluggableIconListMorph;
		at: #Text put: #PluggableTextMorph;
		at: #Button put: #PluggableButtonMorph;
		at: #Panel put: #PanelMorph;
		at: #Checkbox put: #CheckboxMorph;
		at: #DropList put: #DropListMorph;
		at: #TextField put: #PluggableTextFieldMorph;
		at: #Label put: #LabelMorph;
		at: #MultiColumnList put: #PluggableMultiColumnListMorph;
		yourself! !

!ComposableModel class methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 3/22/2012 13:30'!
defaultSelectorsBinding

	^ IdentityDictionary new
		at: #takeKeyboardFocus put: #takeKeyboardFocus;
		yourself! !

!ComposableModel class methodsFor: 'specs' stamp: ''!
internSpec

	^ self subclassresponsibility! !

!ComposableModel class methodsFor: 'instance creation' stamp: ''!
owner: owner

	^ self new
		owner: owner;
		yourself! !

!ComposableModel class methodsFor: 'protocol' stamp: ''!
specSelectors
	
	^ ((PragmaCollector filter: [:prg | prg keyword = 'spec']) reset; collected)
		select: [:e | e method methodClass = self class ] thenCollect: [:e | e method selector ]! !

!ComposableModel class methodsFor: 'specs' stamp: ''!
title
	
	^ 'Untitled window'! !

!ComposableModel class methodsFor: 'specs' stamp: ''!
windowSpec

	^{ #StandardWindow.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	self internSpec.
											#frame:.	(	0@0 corner: 1@1)	}.
			#title:.					self title}! !

!ComposableModel methodsFor: 'private' stamp: ''!
addAll: aWindow withSpec: aSpec

	aWindow
		addMorph: (self buildWithSpec: aSpec)
		frame: (0@0 corner: 1@1).! !

!ComposableModel methodsFor: 'Morphic-Widgets' stamp: ''!
beginsWith: aString fromList: aMorph

	^ false! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
bindings

	^ bindings! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
bindings: anObject

	bindings := anObject! !

!ComposableModel methodsFor: 'protocol' stamp: ''!
buildWithSpec

	^ self buildWithSpec: #internSpec! !

!ComposableModel methodsFor: 'protocol' stamp: ''!
buildWithSpec: aSpec

	^ SpecInterpreter buildMorphFor: self withSpec: aSpec! !

!ComposableModel methodsFor: 'private' stamp: ''!
delete

	morph
		ifNotNil: [ morph owner ifNotNil: [:o | o delete ]]! !

!ComposableModel methodsFor: 'focus' stamp: ''!
eventStringForNextFocus

	^ ''! !

!ComposableModel methodsFor: 'focus' stamp: ''!
eventStringForPreviousFocus

	^ ''! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
focusOrder

	^ focusOrder ifNil: [ focusOrder := OrderedCollection new ].! !

!ComposableModel methodsFor: 'focus' stamp: ''!
giveFocusToNextFrom: aMorph

	| focus |

	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index next |
			index := (focus indexOf: aMorph) + 1.
			(index <= focus size)
				ifTrue: [
					next := focus at: index.
					next takeKeyboardFocus.
					^ true ]].

	^ owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: 1 ifAbsent: [ ^ false ].
			next takeKeyboardFocus.
			true ]
		ifNotNil: [ 
			owner giveFocusToNextFrom: self.
			true ]! !

!ComposableModel methodsFor: 'focus' stamp: ''!
giveFocusToPreviousFrom: aMorph 

	| focus |
	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index previous |
			index := (focus indexOf: aMorph) - 1.
			(index > 0)
				ifTrue: [
					previous := focus at: index.
					previous takeLastKeyboardFocus.
					^ true ]].

	^ owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: focus size ifAbsent: [ false ].
			next takeLastKeyboardFocus.
			true]
		ifNotNil: [ 
			owner giveFocusToPreviousFrom: self.
			true ]! !

!ComposableModel methodsFor: 'focus' stamp: ''!
handlesKeyboard: evt

	^ true! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/23/2012 15:12'!
initialize
	"Initialization code for ComposableModel"

	super initialize.

	bindings := MorphicBindings new.! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/22/2012 14:23'!
initializeClassesBinding

	^ IdentityDictionary new! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/22/2012 14:23'!
initializeSelectorsBinding

	^ IdentityDictionary new! !

!ComposableModel methodsFor: 'instance creation' stamp: ''!
instantiate: aComposableModelClass

	^ aComposableModelClass owner: self! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
internSpec
	<spec>
	^ self class internSpec! !

!ComposableModel methodsFor: 'focus' stamp: ''!
isEventForNextFocus: aKeyboardEvent

	^ false! !

!ComposableModel methodsFor: 'focus' stamp: ''!
isEventForPreviousFocus: aKeyboardEvent 
	
	^ false! !

!ComposableModel methodsFor: 'focus' stamp: ''!
keyStroke: anEvent fromMorph: aMorph

	((self isEventForNextFocus: anEvent) or: [ anEvent keyString = self eventStringForNextFocus])
		ifTrue: [ ^ self giveFocusToNextFrom: aMorph ].
		
	((self isEventForPreviousFocus: anEvent) or: [ anEvent keyString = self eventStringForPreviousFocus])
		ifTrue: [ ^ self giveFocusToPreviousFrom: aMorph ].
		
	^ false! !

!ComposableModel methodsFor: 'Morphic-Widgets' stamp: ''!
listRenderOn: aCanvas atRow: aRow bounds: drawBounds color: drawColor from: aMorph

	morph ifNil: [ self buildWithSpec ].
	morph listRenderOn: aCanvas atRow: aRow bounds: drawBounds color: drawColor from: aMorph	
	! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
morph

	^ morph! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
morph: anObject

	morph := anObject! !

!ComposableModel methodsFor: 'private' stamp: ''!
okToChange

	^ owner 
		ifNil: [
			self canDiscardEdits ifTrue: [^ true].
			self changed: #wantToChange.  "Solicit cancel from view"
			^ self canDiscardEdits]
		ifNotNil: [ owner okToChange ]! !

!ComposableModel methodsFor: 'protocol' stamp: ''!
openMorphWithSpec

	^ self buildWithSpec openInWorld! !

!ComposableModel methodsFor: 'protocol' stamp: ''!
openWithSpec

	^ self openWithSpec: #internSpec.! !

!ComposableModel methodsFor: 'protocol' stamp: ''!
openWithSpec: aSpec
	| window |

	window := StandardWindow new model: self.
	self addAll: window withSpec: aSpec.
	window openInWorld.
	window title: self title.
	self takeKeyboardFocus.
	^ window! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
owner: anObject
	
	owner ifNotNil: [owner removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	owner := anObject.! !

!ComposableModel methodsFor: 'bindings' stamp: 'BenjaminVanRyseghem 3/23/2012 15:07'!
retrieveClassSymbolFor: aSymbol

	^ self bindings
		ifNil: [ self retrieveDefaultClassSymbolFor: aSymbol ]
		ifNotNil: [:bdg | bdg classSymbolFor: aSymbol ifAbsent: [ self retrieveDefaultClassSymbolFor: aSymbol ]]! !

!ComposableModel methodsFor: 'bindings' stamp: 'BenjaminVanRyseghem 3/23/2012 15:06'!
retrieveDefaultClassSymbolFor: aSymbol

	^ self class bindings classSymbolFor: aSymbol ifAbsent: [ aSymbol ]! !

!ComposableModel methodsFor: 'bindings' stamp: 'BenjaminVanRyseghem 3/23/2012 15:11'!
retrieveDefaultSelectorSymbolFor: aSymbol

	^ self class bindings selectorSymbolFor: aSymbol ifAbsent: [ aSymbol ]! !

!ComposableModel methodsFor: 'bindings' stamp: 'BenjaminVanRyseghem 3/23/2012 15:11'!
retrieveSelectorSymbolFor: aSymbol

	^ self bindings
		ifNil: [ self retrieveDefaultSelectorSymbolFor: aSymbol ]
		ifNotNil: [:binding | binding selectorSymbolFor: aSymbol ifAbsent: [ self retrieveDefaultSelectorSymbolFor: aSymbol ]]! !

!ComposableModel methodsFor: 'protocol' stamp: ''!
specSelectors
	
	^ self class specSelectors! !

!ComposableModel methodsFor: 'focus' stamp: ''!
takeKeyboardFocus

	self focusOrder ifNotEmpty:[:focus | ^ focus first takeKeyboardFocus ].
	^ self morph ifNotNil: [:m | m takeKeyboardFocus ]! !

!ComposableModel methodsFor: 'focus' stamp: ''!
takeLastKeyboardFocus

	self focusOrder
		ifEmpty: [ self takeKeyboardFocus ]
		ifNotEmpty: [:focus | focus last takeKeyboardFocus ].! !

!ComposableModel methodsFor: 'protocol' stamp: ''!
title

	^ self class title! !

!ComposableModel methodsFor: 'private' stamp: ''!
update: aParameter

	self changed: aParameter! !

!ComposableModel methodsFor: 'Morphic-Widgets' stamp: ''!
widthToDisplayInList: aList
	
	morph ifNil: [ self buildWithSpec ].
	^ self morph widthToDisplayInList: aList! !

Object subclass: #NewValueHolder
	instanceVariableNames: 'announcer contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!NewValueHolder commentStamp: '<historical>' prior: 0!
A NewValueHolder is a new implementation of ValueHolder based on Announcements!

NewValueHolder subclass: #CollectionValueHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!CollectionValueHolder commentStamp: '<historical>' prior: 0!
A CollectionValueHolder is s a value holder designed for collections!

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject

	| result |
	result := contents add: newObject.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject after: oldObject 
	
	| result |
	result := contents add: newObject after: oldObject.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject afterIndex: index 
	
	| result |
	result := contents add: newObject afterIndex: index.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject before: oldObject
	
	| result |
	result := contents add: newObject before: oldObject.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject beforeIndex: index 
	
	| result |
	result := contents add: newObject beforeIndex: index.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAll: aCollection 
	
	| result |
	result := contents addAll: aCollection.
	self contentsChanged: aCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAllFirst: anOrderedCollection
	
	| result |
	result := contents addAllFirst: anOrderedCollection.
	self contentsChanged: anOrderedCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAllFirstUnlessAlreadyPresent: anOrderedCollection
	
	| result |
	result := contents addAllFirstUnlessAlreadyPresent: anOrderedCollection.
	self contentsChanged: anOrderedCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAllLast: aCollection 
	
	| result |
	result := contents addAllLast: aCollection.
	self contentsChanged: aCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addFirst: newObject 

	| result |
	result := contents addFirst: newObject .
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addLast: newObject 

	| result |
	result := contents addLast: newObject .
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
at: index ifAbsentPut: block

	| result |
	result := contents at: index ifAbsentPut: block.
	self contentsChanged: block value.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
at: index put: value

	| result |
	result := contents at: index put: value.
	self contentsChanged: value.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atAll: aCollection put: anObject 
	
	| result |
	result := contents atAll: aCollection put: anObject .
	self contentsChanged: anObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atAll: indexArray putAll: valueArray
	
	| result |
	result := contents atAll: indexArray putAll: valueArray.
	self contentsChanged: valueArray.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atAllPut: anObject 
	
	| result |
	result := contents atAllPut: anObject.
	self contentsChanged: anObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atLast: indexFromEnd put: obj
	
	| result |
	result := contents atLast: indexFromEnd put: obj.
	self contentsChanged: obj.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atWrap: index put: value
	
	| result |
	result := contents atWrap: index put: value.
	self contentsChanged: value.
	^ result! !

!CollectionValueHolder methodsFor: 'private' stamp: ''!
doesNotUnderstand: aMessage

	^ (contents respondsTo: aMessage selector)
		ifTrue: [ contents perform: aMessage selector withEnoughArguments: aMessage arguments ]
		ifFalse: [ super doesNotUnderstand: aMessage ]! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
insert: anObject before: spot

	| result |
	result := contents insert: anObject before: spot.
	self contentsChanged: anObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
remove: oldObject ifAbsent: absentBlock

	| result |
	result := contents remove: oldObject ifAbsent: absentBlock.
	self contentsChanged: oldObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeAll

	contents removeAll.
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeAt: index

	| result |
	result := contents removeAt: index.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeFirst

	| result |
	result := contents removeFirst.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeFirst: n 

	| result |
	result := contents removeFirst: n .
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeIndex: removedIndex

	| result |
	result := contents removeIndex: removedIndex.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeLast

	| result |
	result := contents removeLast.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeLast: n

	| result |
	result := contents removeLast: n.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
replace: aBlock 

	contents replace: aBlock .
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
replaceAll: oldObject with: newObject 

	contents replaceAll: oldObject with: newObject .
	self contentsChanged: oldObject! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
reset

	contents reset.
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
resetTo: index

	contents resetTo: index.
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'override' stamp: ''!
size 

	^ contents size! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
sort: aSortBlock 

	contents sort: aSortBlock .
	self contentsChanged! !

NewValueHolder subclass: #DictionaryValueHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!DictionaryValueHolder commentStamp: '<historical>' prior: 0!
A DictionaryValueHolder is a value holder designed for dictionaries!

!DictionaryValueHolder methodsFor: 'override' stamp: ''!
at: anObject

	^ contents at: anObject! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
at: key ifAbsentPut: aBlock 

	contents at: key ifAbsentPut: aBlock.
	self contentsChanged: aBlock value! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
at: key put: value

	contents at: key put: value.
	self contentsChanged: value! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
atNewIndex: index put: anObject
	
	contents atNewIndex: index put: anObject.
	self contentsChanged: anObject.! !

!DictionaryValueHolder methodsFor: 'initialization' stamp: ''!
contents

	self error: 'The contents should be accessed directly or you could break the mechanism of events'.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
doesNotUnderstand: aMessage

	^ (contents respondsTo: aMessage selector)
		ifTrue: [ contents perform: aMessage selector withEnoughArguments: aMessage arguments ]
		ifFalse: [ super doesNotUnderstand: aMessage ]! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection keysAndValuesDo: [ :key :value |
		self at: key put: (aBlock value: value) ]! !

!DictionaryValueHolder methodsFor: 'initialization' stamp: ''!
initialize
	"Initialization code for DictionaryValueHolder"

	super initialize.
	self contents: Dictionary new.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
initialize: n
	
	contents initialize: n.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
removeAll
	
	contents removeAll.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
removeKey: key 
	"Remove key from the receiver.
	If key is not in the receiver, notify an error."
	
	^ self removeKey: key ifAbsent: [self errorKeyNotFound: key].! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
removeKey: key ifAbsent: aBlock 
	| result |
	
	result := contents removeKey: key ifAbsent: aBlock.
	self contentsChanged.
	^ result! !

!DictionaryValueHolder methodsFor: 'override' stamp: ''!
size 

	^ contents size! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary 
	
	contents valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary.
	self contentsChanged.! !

!NewValueHolder class methodsFor: 'instance creation' stamp: ''!
contents: contents

	^ self new
		contents: contents;
		yourself! !

!NewValueHolder methodsFor: 'announcements' stamp: ''!
addDependent: aDependent

	self halt: 'Former API, should be changed'.! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contents

	^ contents! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contents: anObject
	
	| oldValue |
	oldValue := contents.
	contents := anObject.
	self contentsChanged: oldValue.! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contentsChanged
	
	announcer announce: (ValueChanged newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contentsChanged: oldValue
	
	announcer announce: (ValueChanged oldContents: oldValue newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contentsChanged: oldValue to: newValue
	
	announcer announce: (ValueChanged oldContents: oldValue newContents: newValue)! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
initialize

	super initialize.
	
	announcer := Announcer new! !

!NewValueHolder methodsFor: 'announcements' stamp: ''!
whenChangedDo: aBlock

	| block |
	block := [:announcement :ann | aBlock cull: announcement newContents cull: announcement oldContents cull: announcement cull: ann ].
	announcer on: ValueChanged do: block! !

!NewValueHolder methodsFor: 'announcements' stamp: ''!
whenChangedSend: aSelector to: aReceiver

	announcer on: ValueChanged send: aSelector to: aReceiver! !

NewValueHolder subclass: #SelectionValueHolder
	instanceVariableNames: 'index selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!SelectionValueHolder commentStamp: '<historical>' prior: 0!
A SelectionValueHolder is a value holder especially designed to contains a list selection (an index + an object)!

!SelectionValueHolder class methodsFor: 'as yet unclassified' stamp: ''!
index: indexValueHolder selection: selectionValueHolder

	^ self new
		index: indexValueHolder;
		selection: selectionValueHolder;
		yourself! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
contents

	^ {index. selection}! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
index

	^ index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
index: anIndex

	index := anIndex.
	self changed: #index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
initialize

	super initialize.
	index := 0 asValueHolder.
	selection := nil asValueHolder.
	
	index whenChangedSend: #contentsChanged to: self.
	selection whenChangedSend: #contentsChanged to: self.! !

!SelectionValueHolder methodsFor: 'protocol' stamp: ''!
reset

	self index contents: 0.
	self selection contents: nil.
	self contentsChanged! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
selection

	^ selection! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
selection: aSelection

	selection := aSelection.
	self changed: #selection! !

!Object methodsFor: '*Spec-Core' stamp: ''!
asValueHolder

	^ NewValueHolder contents: self! !

Object subclass: #SpecInterpreter
	instanceVariableNames: 'instance model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!SpecInterpreter commentStamp: '<historical>' prior: 0!
#model is a magic world to swap the symbol to the model object
!

!SpecInterpreter class methodsFor: 'protocol' stamp: ''!
buildMorphFor: aComposableModel
	
	^ self new buildMorphFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: ''!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self new buildMorphFor: aComposableModel withSpec: aSymbol! !

!SpecInterpreter class methodsFor: 'protocol' stamp: ''!
buildWindowFor: aComposableModel
	
	^ self new buildWindowFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/22/2012 13:18'!
interpretASpec: aSpec model: aModel
	
	^ self new 
		interpretASpec: aSpec
		model: aModel! !

!SpecInterpreter methodsFor: 'building' stamp: ''!
buildMorphFor: aComposableModel
	
	^ self buildMorphFor: aComposableModel withSpec: #internSpec! !

!SpecInterpreter methodsFor: 'building' stamp: ''!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self interpretASpec: (aComposableModel class perform: aSymbol) model: aComposableModel! !

!SpecInterpreter methodsFor: 'building' stamp: ''!
buildWindowFor: aComposableModel
	
	^ self interpretASpec: aComposableModel class windowSpec model: aComposableModel! !

!SpecInterpreter methodsFor: 'bindings' stamp: 'BenjaminVanRyseghem 3/22/2012 13:22'!
convertSymbolOfClassToInstance: aSymbol
	| symbol |
	
	symbol := self retrieveClassSymbolFor: aSymbol.
	
	^ (Smalltalk 
		at: symbol
		ifAbsent: [ ^ aSymbol ]) new! !

!SpecInterpreter methodsFor: 'accessing' stamp: ''!
instance

	^ instance! !

!SpecInterpreter methodsFor: 'accessing' stamp: ''!
instance: anObject
	
	instance := anObject! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 3/23/2012 17:07'!
interpretASpec: aSpec
	| index |

	aSpec ifNil: [ ^ nil ].
	(aSpec isCollection and: [aSpec isSequenceable]) ifFalse: [ ^ aSpec ].
	(aSpec isString or: [ aSpec isText ]) ifTrue: [ 
			^ aSpec == #model
				ifTrue: [ model ]
				ifFalse: [ self convertSymbolOfClassToInstance: aSpec ]].

	" aSpec is an Array "
	instance := self class interpretASpec: aSpec first model: model.
	index := 2.	
	
	[ index <= aSpec size ]
		whileTrue: [ | selector numArgs args newInstance result |
			selector := model retrieveSelectorSymbolFor: (aSpec at: index).
			selector isSymbol
				ifTrue: [ 
					numArgs := selector numArgs.
					args := aSpec copyFrom: index + 1 to: index + numArgs.
					args := args collect: [:each | self class interpretASpec: each model: model].
					index := index + numArgs + 1 ]
				ifFalse: [| array |
					"Here I assume that if it's not a symbol, it's a collection"
					array := selector.
					selector := array first.
					args := array allButFirst.
					args := args collect: [:each | self class interpretASpec: each model: model].
					index := index + 1].
				newInstance := instance perform: selector withArguments: args.
			index > aSpec size
				ifTrue: [
					(model respondsTo: #morph:)
						ifTrue: [ model morph: instance ].
					^ self interpretASpec: newInstance model: instance ].
			instance := newInstance].
	"If you get here, there is a problem. Must probably it comes from the Spec which is wrongly defined"
	self assert: false.
	^ instance! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 3/22/2012 13:20'!
interpretASpec: aSpec model: aModel
	
	self model: aModel.
	^ self interpretASpec: aSpec! !

!SpecInterpreter methodsFor: 'accessing' stamp: ''!
model
	^ model! !

!SpecInterpreter methodsFor: 'accessing' stamp: ''!
model: anObject
	model := anObject! !

!SpecInterpreter methodsFor: 'bindings' stamp: 'BenjaminVanRyseghem 3/22/2012 13:26'!
retrieveClassSymbolFor: aSymbol

	^ model retrieveClassSymbolFor: aSymbol! !
